/*
 * Pidgin - Internet Messenger
 * Copyright (C) Pidgin Developers <devel@pidgin.im>
 *
 * Pidgin is the legal property of its developers, whose names are too numerous
 * to list here. Please refer to the COPYRIGHT file distributed with this
 * source distribution.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see <https://www.gnu.org/licenses/>.
 */

#include <glib/gi18n-lib.h>

#include <purple.h>

#include <adwaita.h>

#include "pidginappearanceprefs.h"
#include "pidgincore.h"

struct _PidginAppearancePrefs {
	AdwPreferencesPage parent;

	GtkWidget *color_scheme;
	GtkWidget *show_formatting;
};

G_DEFINE_FINAL_TYPE(PidginAppearancePrefs, pidgin_appearance_prefs,
                    ADW_TYPE_PREFERENCES_PAGE)

/******************************************************************************
 * Helpers
 *****************************************************************************/
static gboolean
pidgin_appearance_prefs_color_scheme_get_mapping(GValue *value,
                                                 GVariant *variant,
                                                 G_GNUC_UNUSED gpointer data)
{
	const char *color_scheme = NULL;

	if(!g_variant_is_of_type(variant, G_VARIANT_TYPE_STRING)) {
		g_warning("Color scheme setting was unknown type '%s'",
		          g_variant_get_type_string(variant));
		return FALSE;
	}

	color_scheme = g_variant_get_string(variant, NULL);
	if(birb_str_equal(color_scheme, "default")) {
		g_value_set_uint(value, 0);
	} else if(birb_str_equal(color_scheme, "force-dark")) {
		g_value_set_uint(value, 1);
	} else if(birb_str_equal(color_scheme, "force-light")) {
		g_value_set_uint(value, 2);
	} else {
		g_warning("Color scheme setting was unknown value '%s'",
		          color_scheme);
		return FALSE;
	}

	return TRUE;
}

static GVariant *
pidgin_appearance_prefs_color_scheme_set_mapping(const GValue *value,
                                                 const GVariantType *expected_type,
                                                 G_GNUC_UNUSED gpointer data)
{
	const char *color_scheme = NULL;

	if(!g_variant_type_equal(expected_type, G_VARIANT_TYPE_STRING)) {
		g_warning("Color scheme expected type was unknown '%.*s'",
		          (int)g_variant_type_get_string_length(expected_type),
		          g_variant_type_peek_string(expected_type));
		return NULL;
	}

	switch(g_value_get_uint(value)) {
	case 0:
		color_scheme = "default";
		break;
	case 1:
		color_scheme = "force-dark";
		break;
	case 2:
		color_scheme = "force-light";
		break;
	default:
		g_warning("Color scheme setting was unknown value %u",
		          g_value_get_uint(value));
	}

	if(color_scheme != NULL) {
		return g_variant_new_string(color_scheme);
	}

	return NULL;
}

/******************************************************************************
 * GObject Implementation
 *****************************************************************************/
static void
pidgin_appearance_prefs_class_init(PidginAppearancePrefsClass *klass) {
	GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);

	gtk_widget_class_set_template_from_resource(widget_class,
	                                            "/im/pidgin/Pidgin3/Prefs/appearance.ui");

	gtk_widget_class_bind_template_child(widget_class, PidginAppearancePrefs,
	                                     color_scheme);
	gtk_widget_class_bind_template_child(widget_class, PidginAppearancePrefs,
	                                     show_formatting);
}

static void
pidgin_appearance_prefs_init(PidginAppearancePrefs *prefs) {
	GSettings *settings = NULL;

	gtk_widget_init_template(GTK_WIDGET(prefs));

	settings = purple_core_new_settings("im.pidgin.Pidgin3.Appearance");
	g_settings_bind_with_mapping(settings, "color-scheme",
	                             prefs->color_scheme, "selected",
	                             G_SETTINGS_BIND_DEFAULT,
	                             pidgin_appearance_prefs_color_scheme_get_mapping,
	                             pidgin_appearance_prefs_color_scheme_set_mapping,
	                             NULL, NULL);
	g_settings_bind(settings, "show-formatting",
	                prefs->show_formatting, "active", G_SETTINGS_BIND_DEFAULT);
	g_clear_object(&settings);
}

/******************************************************************************
 * API
 *****************************************************************************/
GtkWidget *
pidgin_appearance_prefs_new(void) {
	return g_object_new(PIDGIN_TYPE_APPEARANCE_PREFS, NULL);
}
